diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
similarity index 85%
rename from game/core/src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
index 2442aa9e5..4ecb2bf6d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
@@ -9,19 +9,19 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockOverlayPebbles extends Block
+public class BlockLogicOverlayPebbles extends BlockLogic
 {
-    public BlockOverlayPebbles(String key, String namespaceId, int id, Material material)
+    public BlockLogicOverlayPebbles(Block<?> block, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
         setBlockBounds(0, 0, 0, 1, 0.0625F, 1);
     }
 
     @Override
     public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        Block block = world.getBlock(x, y - 1, z);
-        return block != null && block.blockMaterial.isSolid();
+        Block<?> block = world.getBlock(x, y - 1, z);
+        return block != null && block.getMaterial().isSolid();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockPathDirt.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java
similarity index 76%
rename from game/core/src/main/java/net/minecraft/core/block/BlockPathDirt.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java
index 19b8f929f..2b9271246 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockPathDirt.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java
@@ -8,20 +8,20 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockPathDirt extends Block
+public class BlockLogicPathDirt extends BlockLogic
 {
-	public BlockPathDirt(String key, String namespaceId, int id)
+	public BlockLogicPathDirt(Block<?> block)
     {
-        super(key, namespaceId, id, Material.dirt);
-        setTicking(true);
+        super(block, Material.dirt);
+        block.setTicking(true);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
-        withLightBlock(255);
+        block.withLightBlock(255);
     }
 
     @Override
 	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-        return AABB.getTemporaryBB(x + 0, y + 0, z + 0, x + 1, y + 1, z + 1);
+        return AABB.getTemporaryBB(x, y, z, x + 1, y + 1, z + 1);
     }
 
     @Override
@@ -42,9 +42,9 @@ public class BlockPathDirt extends Block
         super.onNeighborBlockChange(world, x, y, z, blockId);
         Material material = world.getBlockMaterial(x, y + 1, z);
         int id = world.getBlockId(x, y + 1, z);
-        if(material.isSolid() && id != Blocks.FENCE_GATE_PLANKS_OAK.id && id != Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id && id != Blocks.SIGN_WALL_PLANKS_OAK.id)
+        if(material.isSolid() && id != Blocks.FENCE_GATE_PLANKS_OAK.id() && id != Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id() && id != Blocks.SIGN_WALL_PLANKS_OAK.id())
         {
-            world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
+            world.setBlockWithNotify(x, y, z, Blocks.DIRT.id());
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockPiePumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPiePumpkin.java
similarity index 74%
rename from game/core/src/main/java/net/minecraft/core/block/BlockPiePumpkin.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicPiePumpkin.java
index 4248f8671..c14db095c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockPiePumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPiePumpkin.java
@@ -4,12 +4,12 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockPiePumpkin extends BlockEdible
+public class BlockLogicPiePumpkin extends BlockLogicEdible
 {
 
-    public BlockPiePumpkin(String key, String namespaceId, int id)
+    public BlockLogicPiePumpkin(Block<?> block)
     {
-        super(key, namespaceId, id, 4, 5, () -> Items.FOOD_PUMPKIN_PIE);
+        super(block, 4, 5, () -> Items.FOOD_PUMPKIN_PIE);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanks.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanks.java
new file mode 100644
index 000000000..87058f921
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanks.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.World;
+
+public class BlockLogicPlanks extends BlockLogic implements IPaintable {
+    public BlockLogicPlanks(Block<?> block) {
+        super(block, Material.wood);
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        world.setBlock(x, y, z, Blocks.PLANKS_OAK_PAINTED.id());
+        Blocks.PLANKS_OAK_PAINTED.getLogic().setColor(world, x, y, z, color);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockPlanksPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/block/BlockPlanksPainted.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java
index fff3ef678..951d1b47c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockPlanksPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java
@@ -10,11 +10,11 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockPlanksPainted extends Block implements IPainted
+public class BlockLogicPlanksPainted extends BlockLogic implements IPainted
 {
-    public BlockPlanksPainted(String key, String namespaceId, int id)
+    public BlockLogicPlanksPainted(Block<?> block)
     {
-        super(key, namespaceId, id, Material.wood);
+        super(block, Material.wood);
     }
     
     @Override
@@ -46,7 +46,7 @@ public class BlockPlanksPainted extends Block implements IPainted
 
     @Override
     public void removeDye(World world, int x, int y, int z) {
-        world.setBlockWithNotify(x, y, z, Blocks.PLANKS_OAK.id);
+        world.setBlockWithNotify(x, y, z, Blocks.PLANKS_OAK.id());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockPortal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
similarity index 85%
rename from game/core/src/main/java/net/minecraft/core/block/BlockPortal.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
index 1ff1eacf2..85d7ac890 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockPortal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
@@ -10,13 +10,14 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockPortal extends BlockTransparent implements IPainted
+public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
 {
     public static final int MAX_PORTAL_SIZE = 32;
     public static final int MASK_COLOR = 0b1111_0000;
@@ -25,16 +26,16 @@ public class BlockPortal extends BlockTransparent implements IPainted
 
     public static final int ORIENTATION_X = 0;
     public static final int ORIENTATION_Z = 1;
-	public int targetDimension;
-	public int portalFrameId;
-	public int portalTriggerId;
+	public Dimension targetDimension;
+	public Block<?> portalFrame;
+	public Block<?> portalTrigger;
 		
-    public BlockPortal(String key, String namespaceId, int id, int targetDimension, int portalMaterialId, int portalTriggerId)
+    public BlockLogicPortal(Block<?> block, Dimension targetDimension, Block<?> portalMaterial, Block<?> portalTrigger)
     {
-        super(key, namespaceId, id, Material.portal);
+        super(block, Material.portal);
         this.targetDimension = targetDimension;
-        this.portalFrameId = portalMaterialId;
-        this.portalTriggerId = portalTriggerId;
+        this.portalFrame = portalMaterial;
+        this.portalTrigger = portalTrigger;
     }
    
 
@@ -94,12 +95,12 @@ public class BlockPortal extends BlockTransparent implements IPainted
         boolean orientation = false;
         
         // Check if valid dimension
-        if (world.dimension.portalBlockId != -1 && world.dimension.portalBlockId != this.id) return null;
+        if (world.dimension.portalBlock != null && world.dimension.portalBlock != block) return null;
 
         // Sink to minimum Y
         for (int ry = 0; ry > -maxDims; ry--)
         {
-            if (world.getBlockId(x, y + ry, z) == portalFrameId)
+            if (world.getBlockId(x, y + ry, z) == portalFrame.id())
             {
                 foundBottom = true;
                 y += ry;
@@ -107,16 +108,16 @@ public class BlockPortal extends BlockTransparent implements IPainted
             }
         }
 
-        if (foundBottom == false) return null;
+        if (!foundBottom) return null;
 
         y++;
 
-        if (swapOrientation == false)
+        if (!swapOrientation)
         {
         	// Find orientation and minimum bound
         	for (int rx = 0; rx > -maxDims; rx--)
         	{
-        		if (world.getBlockId(x + rx, y, z) == portalFrameId)
+        		if (world.getBlockId(x + rx, y, z) == portalFrame.id())
         		{
         			foundOrientation = true;
         			orientation = false;
@@ -125,11 +126,11 @@ public class BlockPortal extends BlockTransparent implements IPainted
         		}
         	}
         	
-        	if (foundOrientation == false)
+        	if (!foundOrientation)
         	{
         		for (int rz = 0; rz > -maxDims; rz--)
         		{
-        			if (world.getBlockId(x, y, z + rz) == portalFrameId)
+        			if (world.getBlockId(x, y, z + rz) == portalFrame.id())
         			{
         				foundOrientation = true;
         				orientation = true;
@@ -144,7 +145,7 @@ public class BlockPortal extends BlockTransparent implements IPainted
         	// Find orientation and minimum bound
         	for (int rz = 0; rz > -maxDims; rz--)
         	{
-        		if (world.getBlockId(x, y, z + rz) == portalFrameId)
+        		if (world.getBlockId(x, y, z + rz) == portalFrame.id())
         		{
         			foundOrientation = true;
         			orientation = true;
@@ -153,11 +154,11 @@ public class BlockPortal extends BlockTransparent implements IPainted
         		}
         	}
         	
-        	if (foundOrientation == false)
+        	if (!foundOrientation)
         	{
         		for (int rx = 0; rx > -maxDims; rx--)
         		{
-        			if (world.getBlockId(x + rx, y, z) == portalFrameId)
+        			if (world.getBlockId(x + rx, y, z) == portalFrame.id())
         			{
         				foundOrientation = true;
         				orientation = false;
@@ -168,15 +169,15 @@ public class BlockPortal extends BlockTransparent implements IPainted
         	}
         }
 
-        if (foundOrientation == false) return null;
+        if (!foundOrientation) return null;
 
         // Find maximum bound
-        if (orientation == false)
+        if (!orientation)
         {
             // Find in X direction
             for (int rx = 1; rx < maxDims; rx++)
             {
-                if (world.getBlockId(x + rx, y, z) == portalFrameId)
+                if (world.getBlockId(x + rx, y, z) == portalFrame.id())
                 {
                     maxBoundA = rx;
                     break;
@@ -188,7 +189,7 @@ public class BlockPortal extends BlockTransparent implements IPainted
             // Find in Z direction
             for (int rz = 1; rz < maxDims; rz++)
             {
-                if (world.getBlockId(x, y, z + rz) == portalFrameId)
+                if (world.getBlockId(x, y, z + rz) == portalFrame.id())
                 {
                     maxBoundA = rz;
                     break;
@@ -207,7 +208,7 @@ public class BlockPortal extends BlockTransparent implements IPainted
         {
             if (y + ry >= world.getHeightBlocks()) return swapOrientation ? null : getPortalDims(world, ox, oy, oz, true, expectMiddle);
 
-            if (world.getBlockId(x + (orientation == false ? 1 : 0), y + ry, z + (orientation == true ? 1 : 0)) == portalFrameId)
+            if (world.getBlockId(x + (!orientation ? 1 : 0), y + ry, z + (orientation ? 1 : 0)) == portalFrame.id())
             {
                 maxBoundY = ry;
                 break;
@@ -225,16 +226,16 @@ public class BlockPortal extends BlockTransparent implements IPainted
                 // Check edges are correct
                 if (ra == 0 || ra == maxBoundA || ry == 0 || ry == maxBoundY)
                 {
-                    if (world.getBlockId(x + (orientation == false ? ra : 0), y + ry, z + (orientation == true ? ra : 0)) != portalFrameId)
+                    if (world.getBlockId(x + (!orientation ? ra : 0), y + ry, z + (orientation ? ra : 0)) != portalFrame.id())
                     {
                     	return swapOrientation ? null : getPortalDims(world, ox, oy, oz, true, expectMiddle);
                     }
                 }
                 else // Check interior is empty/fire
                 {
-                    int id = world.getBlockId(x + (orientation == false ? ra : 0), y + ry, z + (orientation == true ? ra : 0));
+                    int id = world.getBlockId(x + (!orientation ? ra : 0), y + ry, z + (orientation ? ra : 0));
 
-                    if (id != 0 && id != portalTriggerId && id != this.id)
+                    if (id != 0 && id != portalTrigger.id() && id != block.id())
                     {
                     	return swapOrientation ? null : getPortalDims(world, ox, oy, oz, true, expectMiddle);
                     }
@@ -249,9 +250,9 @@ public class BlockPortal extends BlockTransparent implements IPainted
             {
                 for (int ry = 1; ry < maxBoundY; ry++)
                 {
-                    int id = world.getBlockId(x + (orientation == false ? ra : 0), y + ry, z + (orientation == true ? ra : 0));
+                    int id = world.getBlockId(x + (!orientation ? ra : 0), y + ry, z + (orientation ? ra : 0));
 
-                    if (id != this.id)
+                    if (id != block.id())
                     {
                     	return swapOrientation ? null : getPortalDims(world, ox, oy, oz, true, true);
                     }
@@ -283,7 +284,7 @@ public class BlockPortal extends BlockTransparent implements IPainted
                 int _x = x + (bounds[0] == 0 ? ra : 0);
                 int _y = y + ry;
                 int _z = z + (bounds[0] == 1 ? ra : 0);
-                world.setBlockAndMetadata(_x, _y, _z, this.id, bounds[0] & 0x1);
+                world.setBlockAndMetadata(_x, _y, _z, block.id(), bounds[0] & 0x1);
             }
 
         }
@@ -335,7 +336,7 @@ public class BlockPortal extends BlockTransparent implements IPainted
         }
         if(entity.vehicle == null && entity.passenger == null)
         {
-            entity.handlePortal(this.id, getColor(world, x, y, z));
+            entity.handlePortal(block.id(), getColor(world, x, y, z));
         }
     }
 
@@ -356,7 +357,7 @@ public class BlockPortal extends BlockTransparent implements IPainted
             double xd = (rand.nextDouble() - 0.5D) * 0.5D;
             double yd = (rand.nextDouble() - 0.5D) * 0.5D;
             double zd = (rand.nextDouble() - 0.5D) * 0.5D;
-            if(world.getBlockId(x - 1, y, z) == id || world.getBlockId(x + 1, y, z) == id)
+            if(world.getBlockId(x - 1, y, z) == block.id() || world.getBlockId(x + 1, y, z) == block.id())
             {
                 pz = (double) z + 0.5D + 0.25D * (double)i1;
                 zd = rand.nextFloat() * 2.0D * (double)i1;
@@ -389,7 +390,7 @@ public class BlockPortal extends BlockTransparent implements IPainted
     @Override
     public void removeDye(World world, int x, int y, int z) {
         final int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.STAIRS_PLANKS_OAK.id, stripColorFromMetadata(meta));
+        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.STAIRS_PLANKS_OAK.id(), stripColorFromMetadata(meta));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockPressurePlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
similarity index 87%
rename from game/core/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
index 0ca4062b0..7575767fc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
@@ -13,17 +13,17 @@ import org.jetbrains.annotations.NotNull;
 import java.util.List;
 import java.util.Random;
 
-public class BlockPressurePlate extends Block
+public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic
 {
     public static final int MASK_POWERED = 0b0000_0001;
     public static final int MASK_CEILING = 0b0000_0010;
-    private final Class<? extends Entity> triggerMobClass;
+    private final Class<T> triggerMobClass;
 
-	public BlockPressurePlate(String key, String namespaceId, int id, Class<? extends Entity> mobType, Material material)
+	public BlockLogicPressurePlate(Block<?> block, Class<T> mobType, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
         triggerMobClass = mobType;
-        setTicking(true);
+        block.setTicking(true);
         float pixel = 1 / 16f;
         setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, pixel / 2, 1.0F - pixel);
     }
@@ -100,7 +100,7 @@ public class BlockPressurePlate extends Block
         boolean isCeiling = onCeiling(meta);
         boolean isSteppedOn = false;
         float f = 0.125F;
-        List<Entity> list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB((float)x + f, y + (isCeiling ? .85f : 0f), (float)z + f, (float)(x + 1) - f, (double)y + (isCeiling ? 1 : 0.25D), (float)(z + 1) - f));;
+        List<T> list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB((float)x + f, y + (isCeiling ? .85f : 0f), (float)z + f, (float)(x + 1) - f, (double)y + (isCeiling ? 1 : 0.25D), (float)(z + 1) - f));;
         if(list != null && !list.isEmpty())
         {
             isSteppedOn = true;
@@ -108,22 +108,22 @@ public class BlockPressurePlate extends Block
         if(isSteppedOn && !isPressed)
         {
             world.setBlockMetadataWithNotify(x, y, z, meta | MASK_POWERED);
-            world.notifyBlocksOfNeighborChange(x, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id);
+            world.notifyBlocksOfNeighborChange(x, y, z, id());
+            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id());
             world.markBlocksDirty(x, y, z, x, y, z);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.1D, (double)z + 0.5D, "random.click", 0.3F, 0.6F);
         }
         if(!isSteppedOn && isPressed)
         {
             world.setBlockMetadataWithNotify(x, y, z, meta & ~MASK_POWERED);
-            world.notifyBlocksOfNeighborChange(x, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id);
+            world.notifyBlocksOfNeighborChange(x, y, z, id());
+            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id());
             world.markBlocksDirty(x, y, z, x, y, z);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.1D, (double)z + 0.5D, "random.click", 0.3F, 0.5F);
         }
         if(isSteppedOn)
         {
-            world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+            world.scheduleBlockUpdate(x, y, z, id(), tickDelay());
         }
     }
 
@@ -133,8 +133,8 @@ public class BlockPressurePlate extends Block
         boolean isCeiling = onCeiling(world.getBlockMetadata(x, y, z));
         if(isPressed(data))
         {
-            world.notifyBlocksOfNeighborChange(x, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id);
+            world.notifyBlocksOfNeighborChange(x, y, z, id());
+            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id());
         }
         super.onBlockRemoved(world, x, y, z, data);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockPumice.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
similarity index 77%
rename from game/core/src/main/java/net/minecraft/core/block/BlockPumice.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
index 764b29e48..dc255f166 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockPumice.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
@@ -9,11 +9,11 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockPumice extends Block {
+public class BlockLogicPumice extends BlockLogic {
     final boolean isWet;
-    public BlockPumice(String key, String namespaceId, int id, boolean isWet)
+    public BlockLogicPumice(Block<?> block, boolean isWet)
     {
-        super(key, namespaceId, id, Material.stone);
+        super(block, Material.stone);
         this.isWet = isWet;
     }
 
@@ -23,7 +23,7 @@ public class BlockPumice extends Block {
         super.onBlockPlacedByWorld(world, x, y, z);
         byte radius = 2;
         if(isWet && (inWater(world, x, y, z) || world.dimension.id == Dimension.PARADISE.id)){
-            world.setBlockWithNotify(x, y, z, Blocks.PUMICE_DRY.id);
+            world.setBlockWithNotify(x, y, z, Blocks.PUMICE_DRY.id());
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5D, y + 0.5D, z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for(int l = 0; l < 8; l++)
             {
@@ -34,45 +34,45 @@ public class BlockPumice extends Block {
             for (int _x = x - radius; _x <= x + radius; _x++) {
                 for (int _y = y - radius; _y <= y + radius; _y++) {
                     for (int _z = z - radius; _z <= z + radius; _z++) {
-                        if (Block.hasTag(world.getBlockId(_x, _y, _z), BlockTags.IS_LAVA)) {
+                        if (Blocks.hasTag(world.getBlockId(_x, _y, _z), BlockTags.IS_LAVA)) {
                             world.setBlockWithNotify(_x, _y, _z, 0);
                         }
                     }
                 }
             }
-            world.setBlockWithNotify(x, y, z, Blocks.PUMICE_WET.id);
+            world.setBlockWithNotify(x, y, z, Blocks.PUMICE_WET.id());
         }
     }
 
 
     public boolean inLava(World world, int x, int y, int z){
-        if (Block.hasTag(world.getBlockId(x + 1, y, z), BlockTags.IS_LAVA))
+        if (Blocks.hasTag(world.getBlockId(x + 1, y, z), BlockTags.IS_LAVA))
             return true;
-        if (Block.hasTag(world.getBlockId(x - 1, y, z), BlockTags.IS_LAVA))
+        if (Blocks.hasTag(world.getBlockId(x - 1, y, z), BlockTags.IS_LAVA))
             return true;
-        if (Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.IS_LAVA))
+        if (Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.IS_LAVA))
             return true;
-        if (Block.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_LAVA))
+        if (Blocks.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_LAVA))
             return true;
-        if (Block.hasTag(world.getBlockId(x, y , z + 1), BlockTags.IS_LAVA))
+        if (Blocks.hasTag(world.getBlockId(x, y , z + 1), BlockTags.IS_LAVA))
             return true;
-        if (Block.hasTag(world.getBlockId(x, y , z - 1), BlockTags.IS_LAVA))
+        if (Blocks.hasTag(world.getBlockId(x, y , z - 1), BlockTags.IS_LAVA))
             return true;
         return false;
     }
 
     public boolean inWater(World world, int x, int y, int z){
-        if (Block.hasTag(world.getBlockId(x + 1, y, z), BlockTags.IS_WATER))
+        if (Blocks.hasTag(world.getBlockId(x + 1, y, z), BlockTags.IS_WATER))
             return true;
-        if (Block.hasTag(world.getBlockId(x - 1, y, z), BlockTags.IS_WATER))
+        if (Blocks.hasTag(world.getBlockId(x - 1, y, z), BlockTags.IS_WATER))
             return true;
-        if (Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.IS_WATER))
+        if (Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.IS_WATER))
             return true;
-        if (Block.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_WATER))
+        if (Blocks.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_WATER))
             return true;
-        if (Block.hasTag(world.getBlockId(x, y , z + 1), BlockTags.IS_WATER))
+        if (Blocks.hasTag(world.getBlockId(x, y , z + 1), BlockTags.IS_WATER))
             return true;
-        if (Block.hasTag(world.getBlockId(x, y , z - 1), BlockTags.IS_WATER))
+        if (Blocks.hasTag(world.getBlockId(x, y , z - 1), BlockTags.IS_WATER))
             return true;
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockPumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java
similarity index 66%
rename from game/core/src/main/java/net/minecraft/core/block/BlockPumpkin.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java
index ea902c242..2a79c1605 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockPumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java
@@ -9,16 +9,16 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class BlockPumpkin extends BlockRotatable
+public class BlockLogicPumpkin extends BlockLogicRotatable
 {
     private final boolean isCarvable;
 
-	public BlockPumpkin(String key, String namespaceId, int id, boolean isCarvable)
+	public BlockLogicPumpkin(Block<?> block, boolean isCarvable)
     {
-        super(key, namespaceId, id, Material.vegetable);
-        setTicking(true);
+        super(block, Material.vegetable);
+        block.setTicking(true);
         this.isCarvable = isCarvable;
-        withOverrideColor(MaterialColor.paintedOrange);
+        block.withOverrideColor(MaterialColor.paintedOrange);
     }
 
     @Override
@@ -27,14 +27,10 @@ public class BlockPumpkin extends BlockRotatable
         ItemStack heldItem = player.getHeldItem();
         if (heldItem != null && heldItem.getItem() instanceof ItemToolSword){
             heldItem.damageItem(1,player);
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.PUMPKIN_CARVED_IDLE.id, player.getHorizontalPlacementDirection(Direction.getHorizontalDirection(player).getSide()).getOpposite().getId());
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.PUMPKIN_CARVED_IDLE.id(), player.getHorizontalPlacementDirection(Direction.getHorizontalDirection(player).getSide()).getOpposite().getId());
             return true;
         }
         return false;
     }
 
-    @Override
-    public void onBlockPlacedByWorld(World world, int x, int y, int z)
-    {
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockPumpkinRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/block/BlockPumpkinRedstone.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java
index 5410f5bfe..ccc9ebe0c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockPumpkinRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java
@@ -5,17 +5,17 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockPumpkinRedstone extends BlockRotatable {
+public class BlockLogicPumpkinRedstone extends BlockLogicRotatable {
 
-    public BlockPumpkinRedstone(String translationKey, String namespaceId, int id) {
-        super(translationKey, namespaceId, id, Material.vegetable);
+    public BlockLogicPumpkinRedstone(Block<?> block) {
+        super(block, Material.vegetable);
     }
 
     @Override
     public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
         for (Side s : Side.sides){
-            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id);
+            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id());
         }
     }
 
@@ -23,7 +23,7 @@ public class BlockPumpkinRedstone extends BlockRotatable {
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
         for (Side s : Side.sides){
-            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id);
+            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id());
         }
     }
 
